#version 150

vec4 linear_fog(vec4 inColor, float vertexDistance, float fogStart, float fogEnd, vec4 fogColor) {
    if (vertexDistance <= fogStart) {
        return inColor;
    }
    vec4 fogRealColor = fogColor;
    float fogRealStart = fogStart;
    float fogRealEnd = fogEnd;
    if(fogRealColor.r == 0.0 && fogRealColor.g == 0.0 && fogRealColor.b == 0.0){

        fogRealColor = vec4(54.0 / 255, 21.0 / 255, 53.0 / 255, fogRealColor.a);
        fogRealStart = 8.0;
        fogRealEnd = 32.0;
    }
    else{
        fogRealColor = vec4(55.0 / 255, 55.0 / 255, 55.0 / 255, fogRealColor.a);
    }
    float fogValue = vertexDistance < fogRealEnd ? smoothstep(fogRealStart, fogRealEnd, vertexDistance) : 1.0;
    return vec4(mix(inColor.rgb, fogRealColor.rgb, fogValue * fogRealColor.a), inColor.a);
}

float linear_fog_fade(float vertexDistance, float fogStart, float fogEnd) {
    if (vertexDistance <= fogStart) {
        return 1.0;
    } else if (vertexDistance >= fogEnd) {
        return 0.0;
    }

    return smoothstep(fogEnd, fogStart, vertexDistance);
}

float fog_distance(mat4 modelViewMat, vec3 pos, int shape) {
    if (shape == 0) {
        return length((modelViewMat * vec4(pos, 1.0)).xyz);
    } else {
        float distXZ = length((modelViewMat * vec4(pos.x, 0.0, pos.z, 1.0)).xyz);
        float distY = length((modelViewMat * vec4(0.0, pos.y, 0.0, 1.0)).xyz);
        return max(distXZ, distY);
    }
}
